--- old/usr/src/uts/armv6/bcm2835/unix/Makefile	2015-01-25 13:29:12.010761021 -0500
+++ new/usr/src/uts/armv6/bcm2835/unix/Makefile	2015-01-25 13:29:12.019801282 -0500
@@ -22,6 +22,7 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2015 Josef 'Jeff' Sipek <jeffpc@josefsipek.net>
 #
 
 #
@@ -50,6 +51,11 @@
 
 CTFEXTRAOBJS	= $(OBJS_DIR)/vers.o
 
+ARCHIVE		= boot_archive
+
+INITRD		= initrd
+BOOT_MODULE	= $(ROOT_BCM2835_KERN_DIR)/$(INITRD)
+INITRD_BIN	= $(OBJS_DIR)/$(INITRD)
 
 #
 #	Include common rules.
@@ -60,7 +66,7 @@
 #	Define targets
 #
 ALL_TARGET	= $(UNIX_BIN)
-INSTALL_TARGET	= $(UNIX_BIN) $(ROOTMODULE)
+INSTALL_TARGET	= $(UNIX_BIN) $(ROOTMODULE) $(BOOT_MODULE)
 
 #
 #	This is UNIX_DIR. Use a short path.
@@ -87,6 +93,10 @@
 # The mapfile used to link unix
 MAPFILE		= $(UTSBASE)/armv6/bcm2835/conf/Mapfile
 
+# Tools to build the platform and loader kernel.
+MKPLATFORM	= $(UTSBASE)/$(PLATFORM)/tools/mkplatform
+MKUNI		= $(UTSBASE)/$(PLATFORM)/tools/mkuni
+
 #
 #	Default build targets.
 #
@@ -100,12 +110,7 @@
 
 clobber:	$(CLOBBER_DEPS)
 
-MKPLATFORM	= $(UTSBASE)/$(PLATFORM)/tools/mkplatform.sh
-
-install:  	$(INSTALL_DEPS)
-	pfexec $(MKPLATFORM) -u $(ROOT_BCM2835_MOD_DIR:$(ROOT)/%=/%) $(UNIX_BIN) \
-	    $(GENUNIX_DIR)/$(OBJS_DIR)/genunix
-	$(MV) boot_archive $(OBJS_DIR)/
+install:  	$(INSTALL_DEPS) $(MKPLATFORM) $(MKUNI)
 
 symcheck:       $(SYM_DEPS)
 
@@ -125,6 +130,15 @@
 $(KRTLD_O):	$(KRTLD_OBJECTS)
 	$(LD) -r -o $@ -M$(KRTLD_MAPFILE) $(KRTLD_OBJECTS)
 
+$(MKPLATFORM) $(MKUNI):
+	cd ../../tools && pwd && dmake
+
+$(INITRD_BIN): $(MKPLATFORM) $(MKUNI) $(UNIX_BIN) $(GENUNIX_DIR)/$(OBJS_DIR)/$(GENUNIX)
+	pfexec $(MKPLATFORM) -u $(ROOT_BCM2835_MOD_DIR:$(ROOT)/%=/%) $(UNIX_BIN) \
+	    $(GENUNIX_DIR)/$(OBJS_DIR)/$(GENUNIX)
+	$(MV) $(ARCHIVE) $(OBJS_DIR)/
+	$(MKUNI) $(UNIX_BIN) $(OBJS_DIR)/$(ARCHIVE) $(OBJS_DIR)/$(INITRD)
+
 #
 #	Include common targets.
 #
